<template>
  <div class="serie-album-ctn" :class="{ read: read }">
    <div class="serie-album trunk">
      <a
        v-if="canBeRead && readUrl"
        :href="readUrl"
        @click.prevent="
          $utils.gtmEvent(
            {
              event: 'gtm.event',
              EventCategory: 'Clic_Bouton',
              EventAction: 'Lire',
              EventLabel: `${serie.shelf.name}_${serie.name}`
            },
            readUrl
          )
        "
      >
        <div class="album-cover">
          <img class="cover-img" :src="cover" />
          <div v-if="canBeRead && readUrl" class="album-read">
            <img :src="require('~/assets/images/ic-play-mobile.svg')" />
          </div>
        </div>
      </a>
      <div v-else class="album-cover">
        <img class="cover-img" :src="cover" />
      </div>

      <div class="album-content">
        <div class="album-data">
          <a v-if="!serie.isWebtoon" :href="albumUrl">
            <p class="album-title">{{ albumTitle }}</p>
          </a>
          <p v-else class="album-title">{{ albumTitle }}</p>
          <AlbumBadge
            v-if="album.badge"
            class="album-badge"
            :badge="album.badge"
          />
          <StarRank
            class="only-desktop"
            :avgstar="album.rate.toString()"
            :countnote="album.rateAmount.toString()"
          />
          <p v-if="displaySynopsis" class="album-synopsis only-desktop">
            <span v-html="truncateText"></span>
            <a
              v-if="isTruncated"
              class="text--md text--primary read-more"
              @click="isTruncated = false"
              >{{ $t('catalog.read_more') }}</a
            >
          </p>
          <p v-if="album.preOrder" class="pre-order">
            {{
              `${$t('serie.pre_order')} ${$utils.formatDate(
                album.publicationDate
              )}`
            }}
          </p>
        </div>
        <div class="album-btn">
          <span v-if="read" class="allready-read">
            {{ $t('serie.already_read') }}
          </span>
          <SerieListItemButtons
            :album="album"
            :serie="serie"
            :album-url="albumUrl"
            :is-subscription="isSubscription"
            :connected="connected"
            :subscribed="subscribed"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import AlbumBadge from '~/components/ui/AlbumBadge'
import StarRank from '~/components/ui/StarRank'
import SerieListItemButtons from '~/components/Serie/SerieListItemButtons'

export default {
  components: {
    AlbumBadge,
    StarRank,
    SerieListItemButtons
  },
  props: {
    serie: {
      type: Object,
      required: true
    },
    album: {
      type: Object,
      required: true
    },
    isSubscription: {
      type: Boolean,
      required: false,
      default: false
    },
    connected: {
      type: Boolean,
      required: false,
      default: false
    },
    subscribed: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  data() {
    return { isTruncated: false, currentSerieUrl: '' }
  },
  computed: {
    albumIsFree() {
      return !this.album.price || this.album.price === '0.00'
    },
    albumUrl() {
      const shelf = this.$route.params.shelf
      const genre = this.$route.params.genre
      const slug = this.$route.params.slug

      return `${this.$config.izneoUrl}/${this.$i18n.locale}/${
        this.isSubscription ? 'abo/' : ''
      }${shelf}/${genre}/${slug}/${this.album.slug}-${this.album.id}`
    },
    readUrl() {
      return (
        `${this.albumUrl}/read` +
        (this.currentSerieUrl ? `?exiturl=${this.currentSerieUrl}` : '')
      )
    },
    cover() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/album/${this.album.id}-h260.jpg?v=${this.album.version}`
    },
    read() {
      return this.album.reading >= 100
    },
    preOrder() {
      return false
    },
    truncatedSynopsis() {
      return this.$utils.cutByWords(this.album.synopsis, 200)
    },
    truncateText() {
      let text = this.album.synopsis
      if (this.isTruncated) text = this.truncatedSynopsis

      return text
    },
    displaySynopsis() {
      return !this.serie.isWebtoon
    },
    canBeRead() {
      return (
        this.album.preOrder === false &&
        (this.album.previewAvailable || this.album.fullAvailable)
      )
    },
    getType() {
      return this.album.chapter != null || this.album.chapter === '0'
        ? 'chapter'
        : this.album.volume != null || this.album.volume === '0'
        ? 'volume'
        : 'other'
    },
    albumTitle() {
      let title
      if (this.serie.isWebtoon) {
        title = `${this.$t('common.albumTitles.episode')}${this.album.volume} ${
          this.serie.name
        }`
      } else {
        switch (this.getType) {
          case 'volume':
            title = `${this.$t('common.albumTitles.volume')}${
              this.album.volume
            } ${this.serie.name}`
            break

          case 'chapter':
            title = `${this.$t('common.albumTitles.chapter')}${
              this.album.chapter
            } ${this.serie.name}`
            break

          default:
            title = this.album.title
        }
      }
      return title
    }
  },
  mounted() {
    this.isTruncated = this.album.synopsis !== this.truncatedSynopsis
    this.currentSerieUrl = window.location.href
  }
}
</script>

<style lang="scss" scoped>
.serie-album-ctn {
  padding: 1.5rem 0;
  border-bottom: solid 1px #d8d8d8;

  &.read {
    background-color: #ededed;
    .album-title {
      color: #808080;
    }
  }

  @media (max-width: 768px) {
    padding: 0;

    .trunk {
      padding: 0;
    }
  }

  .serie-album {
    display: flex;
  }

  .album-cover {
    position: relative;

    .album-read {
      position: absolute;
      display: flex;
      justify-content: center;
      align-items: flex-end;
      top: 0;
      left: 0;
      width: 100%;
      height: 220px;

      @media (max-width: 768px) {
        height: 100px;
      }
    }

    .cover-img {
      height: 260px;
      width: auto;
      max-width: inherit;

      @media (max-width: 768px) {
        height: 120px;
      }
    }
  }

  .album-content {
    position: relative;
    display: flex;
    flex: auto;
    padding: 0 1.5rem;

    @media (max-width: 768px) {
      padding: 0 0.5rem;
    }

    .album-data {
      flex: 4;
      display: flex;
      flex-direction: column;
      align-items: self-start;
      padding-right: 6rem;

      @media (max-width: 1259px) {
        padding-right: 2rem;
      }

      .album-title {
        color: #3e3e3e;
        font-size: 30px;
        font-family: DINCond-Bold;

        @media (max-width: 768px) {
          font-size: 20px;
        }
      }

      .album-badge {
        margin-bottom: 0.75rem;
      }

      .album-synopsis {
        font-size: 18px;
        margin-top: 1rem;
      }

      .read-more {
        cursor: pointer;

        text-decoration: underline;
      }
    }

    .album-btn {
      display: flex;
      align-self: flex-end;

      .allready-read {
        position: absolute;
        top: 5px;
        right: 2rem;
        font-family: Arial;
        font-size: 15px;
        color: #808080;
      }
    }
  }

  .pre-order {
    margin-top: 1rem;
    font-family: Arial;
    font-size: 15px;
    color: #808080;
  }

  .only-mobile {
    display: none;
  }

  .only-desktop {
    display: block;
  }

  @media (max-width: 768px) {
    .only-mobile {
      display: block;
    }

    .only-desktop {
      display: none;
    }
  }
}
</style>
